<?php
/**
 * @package     Joomla.Plugin
 * @subpackage  User.profile
 *
 * @copyright   Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('JPATH_PLATFORM') or die;

JFormHelper::loadFieldClass('list');

class JFormFieldLastnamelist extends JFormFieldList {
	protected $type = 'Lastnamelist';

	public function __construct() {
		parent::__construct();
	}

	protected function getOptions() {
		$db =& JFactory::getDBO();
		$query = "SELECT #__opensim_config.configvalue FROM  #__opensim_config WHERE #__opensim_config.configname = 'lastnamelist'";
		$db->setQuery($query);
		$db->query();
		if($db->getNumRows() == 1) {
			$nameliststring = $db->loadAssoc();
		} else {
			$nameliststring['configvalue'] = "error1\nerror2\nerror3\n";
		}
		$namelist = explode("\n",$nameliststring['configvalue']);
		foreach($namelist AS $key => $val) {
			if(!trim($val)) unset($namelist[$key]);
			else $namelist[$key] = trim($val);
		}

		// Initialize variables.
		$options = array();
		

		foreach ($namelist as $option) {

			// Create a new option object based on the <option /> element.
			$tmp = JHtml::_(
				'select.option', (string) $option, trim((string) $option), 'value', 'text'
			);

			// Add the option object to the result set.
			$options[] = $tmp;
		}

		reset($options);

		return $options;
	}

}