<?php
/**
* jOpenSimRegister Plugin for Joomla 2.5
* @version $Id: jOpenSimRegister.php $
* @package: jOpenSimRegister
* ===================================================
* @author
* Name: FoTo50, www.jopensim.com
* Email: info@foto50.com
* Url: http://www.jopensim.com
* ===================================================
* @copyright (C) 2011 FoTo50, (www.jopensim.com). All rights reserved.
* @license see http://www.gnu.org/licenses/gpl-2.0.html  GNU/GPL.
* You can use, redistribute this file and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation.
*/

defined('_JEXEC') or die();

jimport( 'joomla.html.parameter' );
jimport( 'joomla.application.component.view');

class plgUserjOpensimRegister extends JPlugin {
	public $_osgrid_db		= null;
	public $opensim			= null;
	public $_settingsData	= null;
	public $configvalues	= array("lastnametype",
									"lastnamelist",
									"defaulthome",
									"mapstartX",
									"mapstartY",
									"mapstartZ"
									);
	public $debugstop;

	public function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		$this->loadLanguage();
		JFormHelper::addFieldPath(dirname(__FILE__) . '/fields');
	}

	function onContentPrepareForm($form, $data) {
		$task	= JRequest::getVar('task');
		if($task == "nojopensim") {
			return TRUE;
		}
		$formname = $form->getName();
		error_log("Formname: ".$formname." (".__LINE__.")");
/*
		echo "<pre>\n";
		print_r($form->getName());
		echo "</pre>\n";
		exit;
*/
		// Load user_profile plugin language
		$lang = JFactory::getLanguage();
		$lang->load('plg_user_jopensimregister', JPATH_ADMINISTRATOR);

		$registerForms = $this->getEnabledForms();
		$test = serialize($registerForms);

		if (!($form instanceof JForm)) {
			$this->_subject->setError('JERROR_NOT_A_FORM');
			return FALSE;
		}

		$name = $form->getName();

		// Check we are manipulating a valid form.
//		if (!in_array($name, array('com_users.profile', 'com_users.registration','com_users.user','com_admin.profile'))) {
		if ($name != 'com_users.registration') {
			return TRUE;
		}

		// Add the registration fields to the form.
		JForm::addFormPath(dirname(__FILE__) . '/profiles');
		$form->loadFile('profile', false);

		$db =& JFactory::getDBO();
		$query = "SELECT #__opensim_config.configvalue FROM  #__opensim_config WHERE #__opensim_config.configname = 'lastnametype'";
		$db->setQuery($query);
		$db->query();
		if($db->getNumRows() == 1) {
			$type = $db->loadAssoc();
			$lastnametype = $type['configvalue'];
		} else {
			$lastnametype = 0;
		}

		// if allowed names only, we change from text field to select field for lastnames
//		JError::raiseWarning("666","lastnametype: ".$lastnametype);
		if($lastnametype != 1) {
			$form->setFieldAttribute('lastname', 'type', 'text', 'jopensimregister');
			$form->setFieldAttribute('lastname', 'size', '30', 'jopensimregister');
//			$form->setFieldAttribute('lastname', 'multiple', 'false', 'jopensimregister');
		}

		$avatararticle = $this->params->get('plgJopensimRegisterAvatarArticle');
		$avatarenabled = $this->params->get('plgJopensimRegisterAvatarSelect', 0);
//		JError::raiseWarning("666","test: ".$name);

		// We need to be in the registration form, field needs to be enabled and we need an article ID
		if ($name != 'com_users.registration' || !$avatarenabled) {
//			JError::raiseWarning("666","test1: ".$name);
			// We only want the avatar article in the registration form
			$form->removeField('jopensimavatar', 'jopensimregister');
		} else {
//			JError::raiseWarning("666","test2: ".$name." (".$avatararticle.")");
			// Push the article ID into the field.
			$form->setFieldAttribute('jopensimavatar', 'article', $avatararticle, 'jopensimregister');
			$form->setFieldAttribute('jopensimavatar', 'required', TRUE, 'jopensimregister');
			$test = $form->getFieldAttribute('jopensimavatar', 'required');
			error_log("test: ".$test." (".__LINE__.")");
		}



		if ($name == 'com_users.profile' || $name == 'com_users.registration' || $name == 'com_users.user') {
			// Add the profile fields to the form.
//			JForm::addFormPath(dirname(__FILE__).'/profiles');
//			$form->loadFile('profile', FALSE);

			// Toggle whether the something field is required.
			if ($this->params->get('plgJopensimRegisterUser', 'required') == 'required') {
				$form->setFieldAttribute('firstname', 'required', TRUE, 'jopensimregister');
				$form->setFieldAttribute('lastname', 'required', TRUE, 'jopensimregister');
//			} else {
//				$form->removeField('something', 'jopensimregister');
			}
		//In this example, we treat the frontend registration and the back end user create or edit as the same. 
//		} elseif ($form->getName()=='com_users.registration' || $form->getName()=='com_users.user' ) {               
			// Add the registration fields to the form.
//			JForm::addFormPath(dirname(__FILE__).'/profiles');
//			$form->loadFile('profile', FALSE);

			// Toggle whether the something field is required.
//			if ($this->params->get('plgJopensimRegisterUser', 'required') == 'required') {
//				$form->setFieldAttribute('firstname', 'required', TRUE, 'jopensimregister');
//				$form->setFieldAttribute('lastname', 'required', TRUE, 'jopensimregister');
//			} else {
//				$form->removeField('something', 'jopensimregister');
//			}
		}                       
	}



	// before saving, check if First Name/Last Name is free and if Last Name is allowed due to jOpenSim settings
	public function onUserBeforeSave($user,$isnew,$new) {
		if(!$isnew) return TRUE; // Existing users are not needed here

		$firstname	= JArrayHelper::getValue($new['jopensimregister'], 'firstname', null, 'string');
		$lastname	= JArrayHelper::getValue($new['jopensimregister'], 'lastname', null, 'string');

		JPlugin::loadLanguage( 'plg_user_jOpenSimRegister', JPATH_ADMINISTRATOR );

		$option					= JRequest::getVar('option');
		$view					= JRequest::getVar('view');
		$task					= JRequest::getVar('task');
		$retval					= FALSE;
		$plgRegisterjOpenSim	=& JPluginHelper::getPlugin('user', 'jopensimregister');
		$registerForms = $this->getEnabledForms();

		if($option == "com_users" && $task == "register") {
			$retval = $this->checkUser($firstname,$lastname);
		}

		if($option == "com_comprofiler" && $task == "saveregisters" && $registerForms['cb'] == "yes") {
			$retval = $this->checkUser($firstname,$lastname);
		}
		return $retval;
	}

	public function onUserAfterSave($user, $isnew, $result, $error) {
		$userId	= JArrayHelper::getValue($user, 'id', 0, 'int');
		if ($userId && $result && isset($user['jopensimregister']) && (count($user['jopensimregister']))) {
			if(!$isnew) return TRUE; // Existing users are not needed here
			$firstname	= JArrayHelper::getValue($user['jopensimregister'], 'firstname', null, 'string');
			$lastname	= JArrayHelper::getValue($user['jopensimregister'], 'lastname', null, 'string');
			if(isset($user['jopensimregister']['jopensimavatar'])) {
				$avatar = JArrayHelper::getValue($user['jopensimregister'], 'jopensimavatar', null, 'string');
			} else {
				$avatar = null;
			}

//		echo __LINE__;
//		exit;


			$option			= JRequest::getVar('option');
			$task			= JRequest::getVar('task');
			$plgRegisterjOpenSim =& JPluginHelper::getPlugin('user', 'jopensimregister');
//			$this->params   	= new JParameter($plgRegisterjOpenSim->params);
			$registerForms = $this->getEnabledForms();

			// Check out, from that form we get data
			$currentForm = "core";
//			if($option == "com_users" && $task == "register" && $registerForms['joomla'] == "yes")			$currentForm = "core";
//			if($option == "com_comprofiler" && $task == "saveregisters" && $registerForms['cb'] == "yes")	$currentForm = "cb";

			if($currentForm == "core" || $currentForm == "cb") {
				$newuser = array();

				// seems everything went ok, lets save the user in the grid DB


				// now we need to look into the opensim database
				$this->getOpenSimGridDB();
				$this->getSettings();

/*
				echo "<pre>\n";
				echo "\n##### this->_settingsData #####\n";
				print_r($this->_settingsData);
				exit;
*/


				$newuser['firstname'] = $firstname;
				$newuser['lastname'] = $lastname;
				if($avatar) $newuser['avatar'] = $avatar;
				switch($currentForm) {
					case "core":
						$newuser['email']		= $user['email'];
						$newuser['password']	= $user['password_clear'];
					break;
					case "cb":
						$newuser['email']		= $user['email'];
						$newuser['password']	= $user['password'];
					break;
					default: // this should actually never happen
						$newuser['email']		= null;
						$newuser['password']	= null;
					break;
				}
				if($firstname && $lastname) {
					$opensimUID = $this->insertuser($newuser);

					$db =& JFactory::getDBO();
					$query = sprintf("INSERT INTO #__opensim_userrelation (opensimID,joomlaID) VALUES ('%s','%d')",$opensimUID,$user['id']);
					$db->setQuery($query);
					$db->query();
				}
			}
		}
		return TRUE;
	}

	public function onUserBeforeDelete($user) {
		$option			= JRequest::getVar('option');
		$view			= JRequest::getVar('view');
		$task			= JRequest::getVar('task');

/*
		$this->debugprint($option,"option",0);
		$this->debugprint($view,"view",0);
		$this->debugprint($task,"task",0);
		$this->debugprint($user,"user");
*/
		$plgRegisterjOpenSim =& JPluginHelper::getPlugin('user', 'jopensimregister');
		$this->params   	= new JParameter($plgRegisterjOpenSim->params);
		$deleteOpensim = $this->params->get('plgJopensimDeleteUser');
		if($deleteOpensim == "yes") { // if set, delete the opensim account
			// now we need to look into the opensim database
			$this->getOpenSimGridDB();
			$this->getSettings();
			$opensimID = $this->getOpenSimUID($user['id']);
			$onlinestatus = $this->getonlinestatus($opensimID);
			if($onlinestatus) {
				JError::raiseWarning("666",JTEXT::_('PLG_JOPENSIMREGISTER_ERROR_USER_ONLINE'));
				$redirect = "index.php?option=com_users&view=users";
				JRequest::setVar('option',"com_users");
				JRequest::setVar('view',"users");
				JRequest::setVar('task',"");
				JFactory::getApplication()->redirect($redirect);
			}
		}
		
	}

	public function onUserAfterDelete($user) {
		$plgRegisterjOpenSim =& JPluginHelper::getPlugin('user', 'jopensimregister');
		$this->params   	= new JParameter($plgRegisterjOpenSim->params);
		$deleteOpensim = $this->params->get('plgJopensimDeleteUser');
		$db =& JFactory::getDBO();
		if($deleteOpensim == "yes") { // if set, delete the opensim account

			// now we need to look into the opensim database
			$this->getOpenSimGridDB();
			$this->getSettings();



			$opensimID = $this->deleteuser($user['id']);
//			$this->debugprint($opensimID,"opensimID",0);
			// remove stored Offline Messages
			$query = sprintf("DELETE FROM #__opensim_offlinemessages WHERE fromAgentID = '%1\$s' OR toAgentID = '%1\$s'",$opensimID);
			$db->setQuery($query);
			$db->query();
		}


		// delete relation row in jOpenSim component anyway, since this user does not exists anymore
		$query = sprintf("DELETE FROM #__opensim_userrelation WHERE opensimID = '%s'",$opensimID);
		$db->setQuery($query);
		$db->query();


		return TRUE;
	}

	public function getEnabledForms() {
		$plgRegisterjOpenSim	=& JPluginHelper::getPlugin('user', 'jopensimregister');
		$this->params   		= new JParameter($plgRegisterjOpenSim->params);
		$forms['joomla']		= $this->params->get('plgJopensimRegisterFormJoomla');
		$forms['cb']			= $this->params->get('plgJopensimRegisterFormCB');
		$forms['joomlsocial']	= $this->params->get('plgJopensimRegisterFormJS');
		return $forms;
	}

	public function checkUser($firstname,$lastname) {
//		echo "\n### checkUser() triggered! ###\n";
		// now we need to look into the opensim database
		$this->getOpenSimGridDB();

		$plgRegisterjOpenSim	=& JPluginHelper::getPlugin('user', 'jopensimregister');
		$this->params   		= new JParameter($plgRegisterjOpenSim->params);
		$usertype				= $this->params->get('plgJopensimRegisterUser');
		$optional				= JRequest::getVar('enableOpenSim');

		// the opensim fields MUST be both valid when $usertype is required
		if($usertype == "required" && (!$firstname || !$lastname)) {
			$this->returnError(JTEXT::_('PLG_JOPENSIMREGISTER_ERROR_MESSAGE_REQUIRED'));
		}
		// at "optional" creation, the fields must either be both valid or none, not just one of them
		if($usertype == "optional" && (($firstname && !$lastname) || (!$firstname && $lastname))) {
			$this->returnError(JTEXT::_('PLG_JOPENSIMREGISTER_ERROR_MESSAGE_REQUIRED'));
		}
		// in these cases, an opensim account will be created
		if(($usertype == "required" || $usertype == "optional") && $firstname && $lastname) {
			$valid = $this->checkValidName($firstname,$lastname);
			if($valid === FALSE) {
				return FALSE;
			}
		}

		// now everything should be ok, lets return true to create the joomla account and then the opensim account onUserAfterSave
		return TRUE;
	}

	public function getonlinestatus($userid) {
		if(empty($this->_osgrid_db)) $this->getOpenSimGridDB();
		if(!$this->_osgrid_db) return FALSE;
		$opensim = $this->opensim;
		$query = $opensim->getOnlineStatusQuery($userid);
//		$this->debugprint($query,"\$query",0);
		$this->_osgrid_db->setQuery($query);
		$this->_osgrid_db->query();
		$num_rows = $this->_osgrid_db->getNumRows();
		if($num_rows == 1) return TRUE;
		else return FALSE;
	}


	public function returnError($message) {
		$option		= JRequest::getVar('option');
		switch($option) {
			case "com_users":
				$view		= "registration";
				$task		= null;
				$redirect	= "index.php?option=".$option."&view=".$view;
			break;
			case "com_comprofiler":
				$view		= null;
				$task		= "registers";
				$redirect	= "index.php?option=".$option."&task=".$task;
			break;
		}

		$base		= JURI::base();
		$redirect	= $base.$redirect;
		JRequest::setVar('option',$option);
		JRequest::setVar('view',$view);
		JRequest::setVar('task',$task);
		JError::raiseWarning("666",$message);
		return FALSE;
//		JFactory::getApplication()->redirect($redirect);
	}

	// check the name values if they are valid
	public function checkValidName($firstname,$lastname) {
		$existing = $this->checkUserExists($firstname,$lastname);
		if($existing == TRUE) return FALSE; // This OpenSim User is already existing
		else return $this->allowedName($firstname,$lastname);
	}

	public function checkUserExists($firstname,$lastname) {
		if(empty($this->_osgrid_db)) $this->getOpenSimGridDB();
		if(!$this->_osgrid_db) return FALSE;
		$opensim = $this->opensim;
		$checkquery = $opensim->getCheckQuery($firstname,$lastname);
		$this->_osgrid_db->setQuery($checkquery);
		$this->_osgrid_db->query();
		$existing = $this->_osgrid_db->getNumRows();
		if($existing > 0) {
			return TRUE;
			$this->returnError(PLG_JOPENSIMREGISTER_ERROR_MESSAGE_EXISTING);
		} else {
			return FALSE;
		}
	}

	public function allowedName($firstname,$lastname) {
		// lets have a look for allowed or denied lastnames
		$jopensimsettings = $this->getSettings();

		if(			is_array($jopensimsettings) &&
					array_key_exists("lastnametype",$jopensimsettings) &&
					array_key_exists("lastnames",$jopensimsettings) &&
					$jopensimsettings['lastnametype'] != 0 &&
					is_array($jopensimsettings['lastnames']) && 
					count($jopensimsettings['lastnames']) > 0) {
			if($jopensimsettings['lastnametype'] == "-1" && in_array($lastname,$jopensimsettings['lastnames'])) {
				$message = JText::_(PLG_JOPENSIMREGISTER_ERROR_MESSAGE_DENIED);
				$this->returnError($message);
				$retval = FALSE;
			} elseif ($jopensimsettings['lastnametype'] == "1" && !in_array($lastname,$jopensimsettings['lastnames'])) {
				$message = JText::_(PLG_JOPENSIMREGISTER_ERROR_MESSAGE_ALLOWED);
				$this->returnError($message);
				$retval = FALSE;
			} else {
				$retval = TRUE;
			}
		} else {
			$retval = TRUE;
		}
		return $retval;
	}

	public function insertuser($newuser) {
//		echo "<pre>\n";
//		echo "\n##### newuser #####\n";
//		print_r($newuser);
		if(empty($this->_osgrid_db)) $this->getOpenSimGridDB();
		if(!$this->_osgrid_db) return FALSE;
		if(!isset($newuser['uuid']) || !$newuser['uuid']) $newuser['uuid'] = $this->getUUID();
		$newuser['homeregion'] = $this->_settingsData['defaulthome'];
		$newuser['homeposition'] = sprintf("<"."%f,%f,%f".">",$this->_settingsData['mapstartX'],$this->_settingsData['mapstartY'],$this->_settingsData['mapstartZ']);
		$newuser['homelookat'] = "<0,0,0>"; // have to figure out once how to set that exact
		$opensim = $this->opensim;
		$newuser['passwordSalt'] = md5(time());
		$newuser['passwordHash'] = md5(md5($newuser['password']).":".$newuser['passwordSalt']);
		$insertquery = $opensim->getInsertUserQuery($newuser);
//		echo "\n##### insertquery #####\n";
//		print_r($insertquery);
//		echo "</pre>\n";
//		exit;
		$this->_osgrid_db->setQuery($insertquery['user']);
		$retval = $this->_osgrid_db->query();
		$this->_osgrid_db->setQuery($insertquery['auth']);
		$retval = $this->_osgrid_db->query();
		if($this->regionExists($newuser['homeregion'])) { // only add home region if set already
			$this->_osgrid_db->setQuery($insertquery['grid']);
			$retval = $this->_osgrid_db->query();
		}
		$inventoryqueries = $opensim->getinventoryqueries($newuser['uuid']);
		if(is_array($inventoryqueries)) {
			foreach($inventoryqueries AS $query) {
				$this->_osgrid_db->setQuery($query);
				$this->_osgrid_db->query();
			}
		}

		// Lets copy the avatar settings if we need
		if(isset($newuser['avatar']) && $newuser['avatar']) {
			$query = sprintf("INSERT INTO Avatars SELECT '%s' AS PrincipalID, Avatars.`Name`, Avatars.`Value` FROM Avatars WHERE Avatars.PrincipalID = '%s'",
								$newuser['uuid'],
								$newuser['avatar']);
			$this->_osgrid_db->setQuery($query);
			$this->_osgrid_db->query();
			// Only one line needs to be updated:
			$query = sprintf("UPDATE Avatars SET Avatars.`Value` = '%1\$s' WHERE Avatars.PrincipalID = '%1\$s' AND Avatars.`Name` = 'UserID'",
								$newuser['uuid']);
			$this->_osgrid_db->setQuery($query);
			$this->_osgrid_db->query();
		}
		return $newuser['uuid'];
	}

	public function deleteuser($joomlaID) {
		$opensimID = $this->getOpenSimUID($joomlaID);
		if(!$this->_osgrid_db) return FALSE;
		$opensim = $this->opensim;
		$deletequeries = $opensim->getdeletequeries($opensimID);
		if(is_array($deletequeries)) {
			foreach($deletequeries AS $db => $dbquery) {
				foreach($dbquery AS $query) {
					$this->_osgrid_db->setQuery($query);
					$this->_osgrid_db->query();
				}
			}
			return TRUE;
		}
	}

	public function getSettings() {
		$db =& JFactory::getDBO();
		$query = "SELECT * FROM #__opensim_config";
		$db->setQuery($query);
		$jOpenSimSettings = $db->loadAssocList();
		if(is_array($jOpenSimSettings) && count($jOpenSimSettings) > 0) {
			$settings = array();
			foreach($jOpenSimSettings AS $jOpenSimSetting) {
				if(in_array($jOpenSimSetting['configname'],$this->configvalues)) {
					if($jOpenSimSetting['configname'] == "lastnamelist") {
						$lastnames = explode("\n",$jOpenSimSetting['configvalue']);
						if(is_array($lastnames) && count($lastnames) > 0) {
							foreach($lastnames AS $lastname) {
								if(trim($lastname)) $settings['lastnames'][] = trim($lastname);
							}
						}
						$settings['lastnamelist'] = $jOpenSimSetting['configvalue'];
						continue;
					}
					switch($jOpenSimSetting['configtype']) {
						case "int":
							$settings[$jOpenSimSetting['configname']] = intval($jOpenSimSetting['configvalue']);
						break;
						case "float":
							$settings[$jOpenSimSetting['configname']] = floatval($jOpenSimSetting['configvalue']);
						break;
						default:
							$settings[$jOpenSimSetting['configname']] = strval($jOpenSimSetting['configvalue']);
						break;
					}
				}
			}
		}
		$this->_settingsData = $settings;
		return $this->_settingsData;
	}

	public function regionExists($regionID) {
		$opensim = $this->opensim;
		$query = $opensim->regionExistsQuery($regionID);
		$this->_osgrid_db->setQuery($query);
		$existing = $this->_osgrid_db->loadResult();
		if($existing == $regionID) return TRUE;
		else return FALSE;
	}

	public function getOpenSimUID($joomlaID) {
		$db =& JFactory::getDBO();
		$query = sprintf("SELECT
							#__opensim_userrelation.opensimID
						FROM
							#__opensim_userrelation
						WHERE
							#__opensim_userrelation.joomlaID = '%d'",$joomlaID);
		$db->setQuery($query);
		$db->query();
		$num_rows = $db->getNumRows();
		if($num_rows == 1) return $db->loadResult();
		else return null;
	}

	public function getUUID() {
		$db =& JFactory::getDBO();
		$query = "SELECT UUID()";
		$db->setQuery($query);
		$uuid = $db->loadResult();
		return $uuid;
	}

	// Takes the parameters from the component (jOpenSim) and creates the object for the external database
	public function getOpenSimGridDB() {
		$jOpenSim = JComponentHelper::getComponent('com_opensim',TRUE);
		$this->params	= new JParameter($jOpenSim->params);
		$dbhost			= $this->params->get('opensimgrid_dbhost');
		$dbuser			= $this->params->get('opensimgrid_dbuser');
		$dbpass			= $this->params->get('opensimgrid_dbpasswd');
		$dbport			= $this->params->get('opensimgrid_dbport');
		$dbname			= $this->params->get('opensimgrid_dbname');
		// in case of empty grid params, we take the opensim params
		if(!$dbhost) $dbhost = $this->params->get('opensim_dbhost');
		if(!$dbuser) $dbuser = $this->params->get('opensim_dbuser');
		if(!$dbpass) $dbpass = $this->params->get('opensim_dbpasswd');
		if(!$dbport) $dbport = $this->params->get('opensim_dbport');
		if(!$dbname) $dbname = $this->params->get('opensim_dbname');
		if(!$dbport) $dbport = "3306";
		require_once(JPATH_SITE.DS."components".DS."com_opensim".DS."includes".DS."opensim.class.php");
		$this->opensim = new opensim($dbhost,$dbuser,$dbpass,$dbname,$dbport);
		$this->_osgrid_db = $this->opensim->connect2osgrid();
		return $this->_osgrid_db;
	}

	public function debugprint($variable,$desc="",$exit=1) { // I hope I will not forget to remove this function once I dont need it anymore ;)
		return;
		echo "<div align='center'><div align='left'><pre class='debug'>\n\n\n";
		if ($desc) echo "########## $desc ##########\n\n";
		print_r($variable);
		echo "</pre></div></div>\n";
		if ($exit == 1) exit;
	}
}